﻿<?php
// SimplePie-based feed mashup
// http://frans.lowter.us/2010/02/14/simplepie-based-feed-mashup/
// Spread, use, modify, etc. as much as you like. A link back or a comment would be appreciated, but there's no need to. -Frans

// set a few variables
$feed_uri = 'http://some-host/opera-feeds.php'; // Permanent URI for feed, so basically just a reference to where this script is located. Required.
$feed_title = 'Opera Feeds'; // Title, required.
$feed_sub_title = 'Opera News Condensed Into One Feed'; // Not required, some kind of description of the feed.
$feed_icon = 'http://static.myopera.com/favicon.ico'; // Not required, nice for display in supporting feed readers.

// Include the SimplePie library, and the one that handles internationalized domain names.
require_once('../simplepie.inc');
require_once('../idn/idna_convert.class.php');

class SimplePie_XHTML extends SimplePie {
	function fix_xhtml ($html) {
		// Robust, should catch everything.
		if ( function_exists('tidy_parse_string') ) {
			// Tidy config options at http://tidy.sourceforge.net/docs/quickref.html
			// Code almost verbatim from http://www.php.net/manual/en/tidy.examples.basic.php#89334
			$tidy_config = array(
				'clean' => true,
				'output-xhtml' => true,
				'show-body-only' => true,
				'wrap' => 0,
			);
			$tidy = tidy_parse_string($html, $tidy_config, 'UTF8');
			$tidy->cleanRepair();
			// See http://techtrouts.com/webkit-entity-nbsp-not-defined-convert-html-entities-to-xml/ and http://www.sourcerally.net/Scripts/39-Convert-HTML-Entities-to-XML-Entitie
			$xml_ent = array('&#34;','&#38;','&#38;','&#60;','&#62;','&#160;','&#161;','&#162;','&#163;','&#164;','&#165;','&#166;','&#167;','&#168;','&#169;','&#170;','&#171;','&#172;','&#173;','&#174;','&#175;','&#176;','&#177;','&#178;','&#179;','&#180;','&#181;','&#182;','&#183;','&#184;','&#185;','&#186;','&#187;','&#188;','&#189;','&#190;','&#191;','&#192;','&#193;','&#194;','&#195;','&#196;','&#197;','&#198;','&#199;','&#200;','&#201;','&#202;','&#203;','&#204;','&#205;','&#206;','&#207;','&#208;','&#209;','&#210;','&#211;','&#212;','&#213;','&#214;','&#215;','&#216;','&#217;','&#218;','&#219;','&#220;','&#221;','&#222;','&#223;','&#224;','&#225;','&#226;','&#227;','&#228;','&#229;','&#230;','&#231;','&#232;','&#233;','&#234;','&#235;','&#236;','&#237;','&#238;','&#239;','&#240;','&#241;','&#242;','&#243;','&#244;','&#245;','&#246;','&#247;','&#248;','&#249;','&#250;','&#251;','&#252;','&#253;','&#254;','&#255;'); 
			$html_ent = array('&quot;','&amp;','&amp;','&lt;','&gt;','&nbsp;','&iexcl;','&cent;','&pound;','&curren;','&yen;','&brvbar;','&sect;','&uml;','&copy;','&ordf;','&laquo;','&not;','&shy;','&reg;','&macr;','&deg;','&plusmn;','&sup2;','&sup3;','&acute;','&micro;','&para;','&middot;','&cedil;','&sup1;','&ordm;','&raquo;','&frac14;','&frac12;','&frac34;','&iquest;','&Agrave;','&Aacute;','&Acirc;','&Atilde;','&Auml;','&Aring;','&AElig;','&Ccedil;','&Egrave;','&Eacute;','&Ecirc;','&Euml;','&Igrave;','&Iacute;','&Icirc;','&Iuml;','&ETH;','&Ntilde;','&Ograve;','&Oacute;','&Ocirc;','&Otilde;','&Ouml;','&times;','&Oslash;','&Ugrave;','&Uacute;','&Ucirc;','&Uuml;','&Yacute;','&THORN;','&szlig;','&agrave;','&aacute;','&acirc;','&atilde;','&auml;','&aring;','&aelig;','&ccedil;','&egrave;','&eacute;','&ecirc;','&euml;','&igrave;','&iacute;','&icirc;','&iuml;','&eth;','&ntilde;','&ograve;','&oacute;','&ocirc;','&otilde;','&ouml;','&divide;','&oslash;','&ugrave;','&uacute;','&ucirc;','&uuml;','&yacute;','&thorn;','&yuml;');
			$tidy = str_ireplace($html_ent,$xml_ent,$tidy); // Case insensitive for if people do stupid things like &NBSP;.
			return $tidy;
		}
		// Fixes some minor issues with SimplePie, but leaves fundamental problems with input.
		else {
			$xhtml;
			//$self_closing = array ('br', 'hr', 'input', 'img');
			$self_closing = array ('br'); ///only those butchered by SimplePie go in here
			for ($i = 0; $i < count($self_closing); $i++) {
				$xhtml = preg_replace ('/<'.$self_closing[$i].'(.*)>/sU','<'.$self_closing[$i].'\\1/>',$html);
			}
			return $xhtml;
		}
	}
}

// Initialize some feeds for use.
$feed = new SimplePie_XHTML();

// Feeds to be mashed together.
$feed->set_feed_url(array(
	'http://my.opera.com/core/xml/atom/blog/',
	'http://my.opera.com/desktopteam/xml/atom/blog/',
	'http://my.opera.com/haavard/xml/atom/blog/',
	'http://my.opera.com/hallvors/xml/atom/blog/',
	'http://my.opera.com/sitepatching/xml/atom/blog/',
	'http://feeds.feedburner.com/OperaWatch'
));

$feed->set_stupidly_fast ( true ); // remove of set to false if you don't trust the input

// When we set these, we need to make sure that the handler_image.php file is also trying to read from the same cache directory that we are.
//$feed->set_favicon_handler('./handler_image.php');
//$feed->set_image_handler('./handler_image.php');

// Initialize the feed.
$feed->init();

// Make sure the page is being served with the UTF-8 headers.
//$feed->handle_content_type();

header('Content-Type: application/atom+xml;charset=utf-8');
header('Vary: Accept');
?>
<?php if ($feed->error): ?>
		<p><?=$feed->error()?></p>
<?php endif ?>
<feed xmlns="http://www.w3.org/2005/Atom" xml:lang="en">
 <title><?php echo $feed_title; ?></title>
 <subtitle><?php echo $feed_sub_title; ?></subtitle>
 <author><name>Frans</name><uri>http://frans.lowter.us/</uri></author>
 <link rel="self" type="application/atom+xml" href="<?php echo $feed_uri; ?>"/>
 <id><?php echo $feed_uri; ?></id>
<?php if (isset($feed_icon)) { ?>
 <icon><?php echo $feed_icon; ?></icon>
<?php } ?>
 <updated><?php echo $feed->get_item()->get_date('Y-m-d\TH:i:sP');?></updated>
<?php
	// Let's loop through each item in the feed.
	foreach($feed->get_items() as $item):

	// Let's give ourselves a reference to the parent $feed object for this particular item.
	$feed = $item->get_feed();
?>
 <entry>
<?php if ( $item->get_author()->get_name() ) { ?>
	<author>
		<name><?php echo $item->get_author()->get_name(); ?></name>
	</author>
<?php } ?>
	<title type="xhtml"><div xmlns="http://www.w3.org/1999/xhtml" lang="en" dir="ltr"><?php echo strip_tags($item->get_title()); ?></div></title>
	<link rel="alternate" type="text/html" href="<?php echo $item->get_permalink(); ?>"/>
<!--	<summary></summary>-->
	<content type="xhtml"><div xmlns="http://www.w3.org/1999/xhtml">
	<?php //echo $item->get_content(); ?>
	<?php echo $feed->fix_xhtml($item->get_content()); ?>
	</div></content>
	<published><?php echo $item->get_date('Y-m-d\TH:i:sP'); ?></published>
	<updated><?php echo $item->get_date('Y-m-d\TH:i:sP'); ?></updated>
	<id><?php echo $item->get_permalink(); ?></id>
 </entry>
 
<?php endforeach ?>
</feed>